<template>
  <v-row class="ma-0">
    <v-col cols="12">
      <v-pagination
        v-if="pagination.lastPage > 1"
        class="d-inline-block"
        v-model="pagination.currentPage"
        :length="pagination.lastPage"
        :total-visible="10"
        @input="changePage"
      ></v-pagination>
      <span class="float-right"
        >Hiển thị từ {{ pagination.from }} ~ {{ pagination.to }} trong tổng số
        {{ pagination.total }} sản phẩm</span
      >
    </v-col>
    <v-col cols="12">
      <v-simple-table fixed-header height="700px">
        <template v-slot:default>
          <thead>
            <tr>
              <th class="text-center">#</th>
              <th class="text-left">Mã sản phẩm</th>
              <th class="text-left">Tên sản phẩm</th>
              <th class="text-left">Mô tả</th>
              <th class="text-left">Giá</th>
              <th class="text-left">Trạng Thái</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
            <template v-if="items.length > 0">
              <tr v-for="(item, index) in items" :key="item.id">
                <td class="text-center">{{ index + 1 }}</td>
                <td>
                  <v-tooltip bottom color="transparent">
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn plain text v-bind="attrs" v-on="on">
                        {{ item.productId }}
                      </v-btn>
                    </template>
                    <v-img max-width="250" :src="item.productImage"></v-img>
                  </v-tooltip>
                </td>
                <td>{{ item.productName }}</td>
                <td>{{ item.description }}</td>
                <td>{{ toCurrency(item.productPrice) }}</td>
                <td>
                  <span v-if="item.isSales === 1" class="green--text"
                    >Đang bán</span
                  >
                  <span v-else-if="item.isSales === 0" class="red--text"
                    >Ngừng bán</span
                  >
                  <span v-else class="grey--text text-decoration-line-through"
                    >Hết hàng</span
                  >
                </td>
                <td class="text-center">
                  <v-btn
                    icon
                    @click="
                      $router.push({
                        name: 'ProductDataPage',
                        params: { productId: item.productId },
                      })
                    "
                  >
                    <v-icon class="light-blue--text">mdi-pencil</v-icon>
                  </v-btn>
                  <v-btn
                    icon
                    @click="onDelete(item.productId, item.productName)"
                  >
                    <v-icon class="red--text">mdi-trash-can-outline</v-icon>
                  </v-btn>
                </td>
              </tr>
            </template>
            <template v-else>
              <tr>
                <td colspan="7" class="text-center">Không có dữ liệu</td>
              </tr>
            </template>
          </tbody>
        </template>
      </v-simple-table>
    </v-col>
    <v-col cols="12">
      <v-pagination
        v-if="pagination.lastPage > 1"
        class="d-inline-block"
        v-model="pagination.currentPage"
        :length="pagination.lastPage"
        :total-visible="10"
        @input="changePage"
      ></v-pagination>
    </v-col>
  </v-row>
</template>

<script>
export default {
  props: {
    products: {
      type: Array,
      required: true,
      default: [],
    },
    pagination: {
      type: Object,
      required: true,
      default: {},
    },
  },
  data() {
    return {
      items: [],
    };
  },
  watch: {
    products(newVal, oldVal) {
      this.items = newVal;
    },
  },
  methods: {
    changePage(value) {
      this.$emit("onChangePage", {
        key: "page",
        value,
      });
    },
    onEdit(id) {
      this.$emit("onEdit", id);
    },
    onDelete(productId, productName) {
      this.$emit("onDelete", { productId, productName });
    },
    toCurrency(value = 0) {
      value = Number(value);
      return (
        "$" + value.toFixed(2).replace(/(\d)(?=(\d{3})+(?:\.\d+)?$)/g, "$1,")
      );
    },
  },
  created() {},
};
</script>
<style scoped></style>
